com.jnape.palatable.lambda.semigroup.builtin

## Class Absent<A>

- java.lang.Object
- - com.jnape.palatable.lambda.semigroup.builtin.Absent<A>

- Type Parameters:
    `A` - the Maybe value parameter type
  All Implemented Interfaces:
    Fn1<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>>, Fn2<Semigroup<A>,Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>, Fn3<Semigroup<A>,Maybe<A>,Maybe<A>,Maybe<A>>, SemigroupFactory<Semigroup<A>,Maybe<A>>, Applicative<Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>, Cartesian<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<?,?>>, Cocartesian<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<?,?>>, Contravariant<Semigroup<A>,Profunctor<?,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<?,?>>>, Functor<Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>, Profunctor<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<?,?>>, Monad<Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>, MonadReader<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>, MonadRec<Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>, MonadWriter<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>,Fn1<Semigroup<A>,?>>

      public final class Absent<A>
      extends Object
      implements SemigroupFactory<Semigroup<A>,Maybe<A>>

  A `Semigroup` instance formed by ``Maybe`<A>` and a semigroup over `A`. The application to two `Maybe` values is absence-biased, such that for a given `Maybe` `x` and `y`:
  - if `x` is absent, the result is `x`
  - if `x` is present and `y` is absent, the result is `y`
  - if both `x` and `y` are present, the result is the application of the x and y values in terms of the provided semigroup, wrapped in `Maybe.just(A)`
  See Also:
    `Semigroup`, `Present`, `Maybe`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <A> Absent<A>` | `absent()`
    `static <A> Semigroup<Maybe<A>>` | `absent(Semigroup<A> semigroup)`
    `static <A> Fn1<Maybe<A>,Maybe<A>>` | `absent(Semigroup<A> aSemigroup, Maybe<A> x)`
    `static <A> Maybe<A>` | `absent(Semigroup<A> semigroup, Maybe<A> x, Maybe<A> y)`
    `Semigroup<Maybe<A>>` | `checkedApply(Semigroup<A> aSemigroup)` Invoke this function with the given argument, potentially throwing any `Throwable`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.SemigroupFactory

      `apply, checkedApply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Semigroup<Maybe<A>> checkedApply(Semigroup<A> aSemigroup)

      Description copied from interface: `Fn2`
      Invoke this function with the given argument, potentially throwing any `Throwable`.
      Specified by:
        `checkedApply` in interface `Fn1<Semigroup<A>,Fn1<Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>>`
      Specified by:
        `checkedApply` in interface `Fn2<Semigroup<A>,Maybe<A>,Fn1<Maybe<A>,Maybe<A>>>`
      Specified by:
        `checkedApply` in interface `SemigroupFactory<Semigroup<A>,Maybe<A>>`
      Parameters:
        `aSemigroup` - the argument
      Returns:
        the result of the function application

    - #### absent

          public static <A> Absent<A> absent()

    - #### absent

          public static <A> Semigroup<Maybe<A>> absent(Semigroup<A> semigroup)

    - #### absent

          public static <A> Fn1<Maybe<A>,Maybe<A>> absent(Semigroup<A> aSemigroup,
                                                          Maybe<A> x)

    - #### absent

          public static <A> Maybe<A> absent(Semigroup<A> semigroup,
                                            Maybe<A> x,
                                            Maybe<A> y)